Index: trunk/source/Lib/TLibRenderer/TRenSingleModel.cpp
===================================================================
--- trunk/source/Lib/TLibRenderer/TRenSingleModel.cpp	(revision 1387)
+++ trunk/source/Lib/TLibRenderer/TRenSingleModel.cpp	(revision 1396)
@@ -1395,252 +1262,110 @@
   RM_AOT( iSubSourcePos >  (1 << m_iShiftPrec) );
   RM_AOT( iTargetSPos   < 0                    );
-  RM_AOT( iTargetSPos   >= m_iWidth            );  
-
-  RenModelOutPels* pcOutSample = m_pcOutputSamplesRow              + iTargetSPos;
-  RenModelInPels * pcInSample  = m_pcInputSamplesRow[VIEWPOS_LEFT] + iSourcePos ;
-
-  if ( iBM != BLEND_NONE )
-  {
-    xSetShiftedPelBlendL<bSet>  (pcInSample, iSubSourcePos, pcOutSample, iFilled, riError);
-  }
-  else
-  {
-    xSetShiftedPelNoBlendL<bSet>(pcInSample, iSubSourcePos, pcOutSample, iFilled, riError);
-  }
-}
-
-template <BlenMod iBM, Bool bBitInc> template<Bool bSet> __inline Void
-TRenSingleModelC<iBM,bBitInc>::xSetShiftedPelNoBlendL(RenModelInPels* pcInSample, Int iSubSourcePos, RenModelOutPels* pcOutSample, Pel iFilled, RMDist& riError )
-{
-  if ( bSet )
-  { 
-    // Filled
-    pcOutSample->iFilledLeft = iFilled;
-
-    // Yuv
-    pcOutSample->iYLeft  = pcInSample->aiY[iSubSourcePos];
-#if H_3D_VSO_COLOR_PLANES
-    pcOutSample->iULeft  = pcInSample->aiU[iSubSourcePos];
-    pcOutSample->iVLeft  = pcInSample->aiV[iSubSourcePos];
-
-    pcOutSample->iError = xGetDist( pcOutSample->iYLeft - pcOutSample->iYRef,
-                                    pcOutSample->iULeft - pcOutSample->iURef,    
-                                    pcOutSample->iVLeft - pcOutSample->iVRef
-                                  );    
-#else
-    pcOutSample->iError = xGetDist( pcOutSample->iYLeft - pcOutSample->iYRef );    
+  RM_AOT( iTargetSPos   >= m_iWidth            );
+
+  RenModelInPels * pcInSample  = m_pcInputSamplesRow[ bL ? VIEWPOS_LEFT : VIEWPOS_RIGHT ] + iSourcePos ;
+
+  Pel iY;
+  Pel iYCurNew = pcInSample->aiY[iSubSourcePos];    
+#if H_3D_VSO_COLOR_PLANES
+  Pel iU;
+  Pel iUCurNew = pcInSample->aiU[iSubSourcePos];
+  Pel iV;
+  Pel iVCurNew = pcInSample->aiV[iSubSourcePos];;
 #endif    
-    
+
+  const Bool bFullMode = ( bSM == GET_FULL || bSM == SET_FULL ); 
+
+  RenModelOutPels*    pcOutSample    = bFullMode ? ( m_pcOutputSamplesRow    + iTargetSPos ) : NULL; 
+  RenModelLimOutPels* pcLimOutSample = bFullMode ? NULL  : ( m_pcLimOutputSamplesRow + iTargetSPos ); 
+
+  if ( iBM == BLEND_NONE )
+  {
+    iY = iYCurNew; 
+#if H_3D_VSO_COLOR_PLANES
+    iU = iUCurNew; 
+    iV = iVCurNew; 
+#endif
   }
   else
   { 
-#if H_3D_VSO_COLOR_PLANES
-    riError += xGetDist( pcInSample->aiY[iSubSourcePos] - pcOutSample->iYRef,
-                         pcInSample->aiU[iSubSourcePos] - pcOutSample->iURef,
-                         pcInSample->aiV[iSubSourcePos] - pcOutSample->iVRef
-                       );
-#else               
-    riError += xGetDist( pcInSample->aiY[iSubSourcePos] - pcOutSample->iYRef );
-#endif
-
-    riError -= pcOutSample->iError;
-  }
-}
-
-template <BlenMod iBM, Bool bBitInc> template<Bool bSet> __inline Void
-TRenSingleModelC<iBM,bBitInc>::xSetShiftedPelBlendL(RenModelInPels* pcInSample, Int iSubSourcePos, RenModelOutPels* pcOutSample, Pel iFilled, RMDist& riError )
-{
-  Pel piBlendedValueY;
-#if H_3D_VSO_COLOR_PLANES
-  Pel piBlendedValueU;
-  Pel piBlendedValueV;
-#endif
-
-  xGetBlendedValue (
-    pcInSample ->aiY[iSubSourcePos],
-    pcOutSample->iYRight,    
-#if H_3D_VSO_COLOR_PLANES
-    pcInSample ->aiU[iSubSourcePos],
-    pcOutSample->iURight,    
-    pcInSample ->aiV[iSubSourcePos],
-    pcOutSample->iVRight,    
-#endif
-    m_piInvZLUTLeft [RenModRemoveBitInc(m_iThisDepth)        ],
-    m_piInvZLUTRight[RenModRemoveBitInc(pcOutSample->iDRight)],
-    iFilled,
-    pcOutSample->iFilledRight  ,
-    piBlendedValueY
-#if H_3D_VSO_COLOR_PLANES
-    , piBlendedValueU,
-    piBlendedValueV
-#endif
-    );
-
-  if ( bSet )
+    Pel iYOther      = bFullMode ? ( bL ? pcOutSample->iYRight : pcOutSample->iYLeft) : pcLimOutSample->iYOther; 
+#if H_3D_VSO_COLOR_PLANES
+    Pel iUOther      = bFullMode ? ( bL ? pcOutSample->iURight : pcOutSample->iULeft ) : pcLimOutSample->iUOther; 
+    Pel iVOther      = bFullMode ? ( bL ? pcOutSample->iVRight : pcOutSample->iVLeft ) : pcLimOutSample->iVOther; 
+#endif
+    Int iFilledOther = bFullMode ? ( bL ? pcOutSample->iFilledRight : pcOutSample->iFilledLeft ) : pcLimOutSample->iFilledOther; 
+    Pel iDOther      = bFullMode ? ( bL ? pcOutSample->iDRight      : pcOutSample->iDLeft      ) : pcLimOutSample->iDOther; 
+
+    xGetBlendedValue<bL, bSM>(
+      iY,
+      bL ? iYCurNew : iYOther,
+      bL ? iYOther  : iYCurNew,
+#if H_3D_VSO_COLOR_PLANES
+      iU,
+      bL ? iUCurNew  : iUOther,
+      bL ? iUOther   : iUCurNew,
+      iV,
+      bL ? iVCurNew  : iVOther,
+      bL ? iVOther   : iVCurNew,          
+#endif
+      bL ? iFilled      : iFilledOther,
+      bL ? iFilledOther : iFilled,
+      m_piInvZLUTLeft [RenModRemoveBitInc( bL ? m_iThisDepth : iDOther)],
+      m_piInvZLUTRight[RenModRemoveBitInc( bL ? iDOther      : m_iThisDepth)]
+      ); 
+  }
+
+
+  Int iDist = xGetDist( 
+    iY - ( bFullMode ? pcOutSample->iYRef : pcLimOutSample->iYRef ) 
+#if H_3D_VSO_COLOR_PLANES
+  , iU - ( bFullMode ? pcOutSample->iURef : pcLimOutSample->iURef )
+  , iV - ( bFullMode ? pcOutSample->iVRef : pcLimOutSample->iVRef )
+#endif
+  );
+
+  if ( bSM == GET_FULL || bSM == GET_SIMP )
   {    
-    // Set values
-    pcOutSample->iDLeft      = m_iThisDepth;
-    pcOutSample->iYLeft      = pcInSample ->aiY[iSubSourcePos];
-    pcOutSample->iYBlended   = piBlendedValueY;    
-#if H_3D_VSO_COLOR_PLANES  
-    pcOutSample->iULeft      = pcInSample ->aiU[iSubSourcePos];
-    pcOutSample->iUBlended   = piBlendedValueU;    
-    pcOutSample->iVLeft      = pcInSample ->aiV[iSubSourcePos];
-    pcOutSample->iVBlended   = piBlendedValueV;    
-#endif
-    pcOutSample->iFilledLeft = iFilled;
-
-    // Get Error
-    Int iDiffY = pcOutSample->iYRef - piBlendedValueY;
-#if H_3D_VSO_COLOR_PLANES
-    Int iDiffU = pcOutSample->iURef - piBlendedValueU;
-    Int iDiffV = pcOutSample->iVRef - piBlendedValueV;
-    pcOutSample->iError  = xGetDist(iDiffY, iDiffU, iDiffV );
-#else
-    pcOutSample->iError  = xGetDist(iDiffY );
-#endif
-  }
-  else
-  {
-    Int iDiffY = pcOutSample->iYRef - piBlendedValueY;
-#if H_3D_VSO_COLOR_PLANES
-    Int iDiffU = pcOutSample->iURef - piBlendedValueU;
-    Int iDiffV = pcOutSample->iVRef - piBlendedValueV;
-    riError   += ( xGetDist( iDiffY, iDiffU, iDiffV ) - pcOutSample->iError );
-
-#else
-    riError   += ( xGetDist( iDiffY ) - pcOutSample->iError  );
-#endif
-
-  }
-}
-
-
-template <BlenMod iBM, Bool bBitInc> template<Bool bSet> __inline Void
-TRenSingleModelC<iBM,bBitInc>::xSetShiftedPelR(Int iSourcePos, Int iSubSourcePos, Int iTargetSPos, Pel iFilled, RMDist& riError )
-{
-  RM_AOT( iSourcePos    <  0                     );
-  RM_AOT( iSourcePos    >= m_iWidth              );
-  RM_AOT( iSubSourcePos <  0                     );
-  RM_AOT( iSubSourcePos >= (1 << m_iShiftPrec)+1 );
-  RM_AOT( iTargetSPos   < 0                      );
-  RM_AOT( iTargetSPos   >= m_iWidth              );  
-
-  RenModelOutPels* pcOutSample = m_pcOutputSamplesRow               + iTargetSPos;
-  RenModelInPels * pcInSample  = m_pcInputSamplesRow[VIEWPOS_RIGHT] + iSourcePos ;
-
-  if ( iBM != BLEND_NONE )
-  {
-    xSetShiftedPelBlendR<bSet>   (pcInSample, iSubSourcePos, pcOutSample, iFilled, riError);
-  }
-  else
-  {
-    xSetShiftedPelNoBlendR<bSet> (pcInSample, iSubSourcePos, pcOutSample, iFilled, riError);
-  }
-}
-
-template <BlenMod iBM, Bool bBitInc> template<Bool bSet> __inline Void
-TRenSingleModelC<iBM,bBitInc>::xSetShiftedPelNoBlendR(RenModelInPels* pcInSample, Int iSubSourcePos, RenModelOutPels* pcOutSample, Pel iFilled, RMDist& riError )
-{
-  if ( bSet )
-  { 
-    // Filled
-    pcOutSample->iFilledRight = iFilled;
-
-    // Yuv
-    pcOutSample->iYRight  = pcInSample->aiY[iSubSourcePos];
-#if H_3D_VSO_COLOR_PLANES
-    pcOutSample->iURight  = pcInSample->aiU[iSubSourcePos];
-    pcOutSample->iVRight  = pcInSample->aiV[iSubSourcePos];
-
-    pcOutSample->iError = xGetDist( 
-      pcOutSample->iYRight - pcOutSample->iYRef,
-      pcOutSample->iURight - pcOutSample->iURef,    
-      pcOutSample->iVRight - pcOutSample->iVRef
-      );    
-#else
-    pcOutSample->iError = xGetDist( pcOutSample->iYRight - pcOutSample->iYRef );    
-#endif    
-
-  }
-  else
-  { 
-#if H_3D_VSO_COLOR_PLANES
-    riError += xGetDist( pcInSample->aiY[iSubSourcePos] - pcOutSample->iYRef,
-      pcInSample->aiU[iSubSourcePos] - pcOutSample->iURef,
-      pcInSample->aiV[iSubSourcePos] - pcOutSample->iVRef
-      );
-#else               
-    riError += xGetDist( pcInSample->aiY[iSubSourcePos] - pcOutSample->iYRef );
-#endif
-
-    riError -= pcOutSample->iError;
-  }
-}
-
-template <BlenMod iBM, Bool bBitInc> template<Bool bSet> __inline Void
-TRenSingleModelC<iBM,bBitInc>::xSetShiftedPelBlendR(RenModelInPels* pcInSample, Int iSubSourcePos, RenModelOutPels* pcOutSample, Pel iFilled, RMDist& riError )
-{
-  Pel piBlendedValueY;
-#if H_3D_VSO_COLOR_PLANES
-  Pel piBlendedValueU;
-  Pel piBlendedValueV;
-#endif
-
-  xGetBlendedValue (
-    pcOutSample->iYLeft, 
-    pcInSample ->aiY[iSubSourcePos],        
-#if H_3D_VSO_COLOR_PLANES
-    pcOutSample->iULeft,    
-    pcInSample ->aiU[iSubSourcePos],
-    pcOutSample->iVLeft,    
-    pcInSample ->aiV[iSubSourcePos],
-#endif
-    m_piInvZLUTLeft  [RenModRemoveBitInc(pcOutSample->iDLeft)],
-    m_piInvZLUTRight [RenModRemoveBitInc(m_iThisDepth)       ],
-    pcOutSample->iFilledLeft,
-    iFilled,
-    piBlendedValueY
-#if H_3D_VSO_COLOR_PLANES
-    , piBlendedValueU,
-    piBlendedValueV
-#endif
-    );
-
-  if ( bSet )
-  {    
-    // Set values
-    pcOutSample->iDRight     = m_iThisDepth;
-    pcOutSample->iYRight     = pcInSample ->aiY[iSubSourcePos];
-    pcOutSample->iYBlended   = piBlendedValueY;    
-#if H_3D_VSO_COLOR_PLANES  
-    pcOutSample->iURight     = pcInSample ->aiU[iSubSourcePos];
-    pcOutSample->iUBlended   = piBlendedValueU;    
-    pcOutSample->iVRight     = pcInSample ->aiV[iSubSourcePos];
-    pcOutSample->iVBlended   = piBlendedValueV;    
-#endif
-    pcOutSample->iFilledRight = iFilled;
-
-    // Get Error
-    Int iDiffY = pcOutSample->iYRef - piBlendedValueY;
-#if H_3D_VSO_COLOR_PLANES
-    Int iDiffU = pcOutSample->iURef - piBlendedValueU;
-    Int iDiffV = pcOutSample->iVRef - piBlendedValueV;
-    pcOutSample->iError  = xGetDist(iDiffY, iDiffU, iDiffV );
-#else
-    pcOutSample->iError  = xGetDist(iDiffY );
-#endif
-  }
-  else
-  {
-    Int iDiffY = pcOutSample->iYRef - piBlendedValueY;
-#if H_3D_VSO_COLOR_PLANES
-    Int iDiffU = pcOutSample->iURef - piBlendedValueU;
-    Int iDiffV = pcOutSample->iVRef - piBlendedValueV;
-    riError   += ( xGetDist( iDiffY, iDiffU, iDiffV ) - pcOutSample->iError );
-#else
-    riError   += ( xGetDist( iDiffY ) -  pcOutSample->iError  );
-#endif
-  }
+    riError += ( iDist - ( bFullMode ? pcOutSample->iError : pcLimOutSample->iError ) );
+  }
+  else // bSM == SET_FULL
+  {
+    Int& riErrorStr = bFullMode ? pcOutSample->iError : pcLimOutSample->iError; 
+    riErrorStr      = iDist; 
+
+    if ( bFullMode )
+    {     
+      if ( iBM != BLEND_NONE )
+      {        
+        pcOutSample->iYBlended   = iY; 
+#if H_3D_VSO_COLOR_PLANES
+        pcOutSample->iUBlended   = iU; 
+        pcOutSample->iVBlended   = iV; 
+#endif
+      }
+
+      if ( bL )
+      {
+        pcOutSample->iDLeft      = m_iThisDepth; 
+        pcOutSample->iFilledLeft = iFilled; 
+        pcOutSample->iYLeft      = iYCurNew;
+#if  H_3D_VSO_COLOR_PLANES
+        pcOutSample->iULeft      = iUCurNew;
+        pcOutSample->iVLeft      = iVCurNew;
+#endif
+      }
+      else
+      {
+        pcOutSample->iDRight      = m_iThisDepth; 
+        pcOutSample->iFilledRight = iFilled; 
+        pcOutSample->iYRight      = iYCurNew;
+#if  H_3D_VSO_COLOR_PLANES
+        pcOutSample->iURight      = iUCurNew;
+        pcOutSample->iVRight      = iVCurNew;
+#endif
+      }
+    }
+  }    
 }
 
@@ -1687,13 +1412,12 @@
 
 
-#if H_3D_VSO_COLOR_PLANES
-template <BlenMod iBM, Bool bBitInc>  __inline Void
-TRenSingleModelC<iBM,bBitInc>::xGetBlendedValue( Pel iYL, Pel iYR, Pel iUL, Pel iUR, Pel iVL, Pel iVR, Pel iDepthL, Pel iDepthR, Int iFilledL, Int iFilledR, Pel& riY, Pel& riU, Pel&riV )
-#else
-template <BlenMod iBM, Bool bBitInc>  __inline Void
-TRenSingleModelC<iBM,bBitInc>::xGetBlendedValue( Pel iYL, Pel iYR, Pel iDepthL, Pel iDepthR, Int iFilledL, Int iFilledR, Pel& riY )
-#endif
-{
-
+
+template <BlenMod iBM, Bool bBitInc>  template< Bool bL, SetMod bSM > __inline Void
+  TRenSingleModelC<iBM,bBitInc>::xGetBlendedValue( Pel& riY, Pel iYL,  Pel iYR,  
+#if H_3D_VSO_COLOR_PLANES
+                                                   Pel& riU, Pel iUL,  Pel iUR,  Pel& riV, Pel iVL,  Pel iVR,  
+#endif
+                                                   Int iFilledL,  Int iFilledR, Pel iDepthL,  Pel iDepthR  )
+{  
   RM_AOT( iBM != BLEND_AVRG && iBM != BLEND_LEFT && iBM != BLEND_RIGHT );
 
@@ -1702,17 +1426,17 @@
     if (iBM == BLEND_LEFT )
     {
-#if H_3D_VSO_COLOR_PLANES
-      xGetBlendedValueBM1(  iYL,  iYR,  iUL,  iUR,  iVL,  iVR,  iDepthL,  iDepthR,  iFilledL,  iFilledR,  riY,  riU, riV );
-#else
-      xGetBlendedValueBM1(  iYL,  iYR,  iDepthL,  iDepthR,  iFilledL,  iFilledR,  riY );
-#endif
+      xGetBlendedValueBM1<bL, bSM>( riY, iYL,  iYR,  
+#if H_3D_VSO_COLOR_PLANES
+        riU, iUL,  iUR,  riV, iVL,  iVR,  
+#endif
+        iFilledL,  iFilledR, iDepthL,  iDepthR  );
     }
     else
     {
-#if H_3D_VSO_COLOR_PLANES
-      xGetBlendedValueBM2(  iYL,  iYR,  iUL,  iUR,  iVL,  iVR,  iDepthL,  iDepthR,  iFilledL,  iFilledR,  riY,  riU, riV );
-#else
-      xGetBlendedValueBM2(  iYL,  iYR, iDepthL,  iDepthR,  iFilledL,  iFilledR,  riY );
-#endif
+      xGetBlendedValueBM2<bL, bSM>(  riY, iYL,  iYR,  
+#if H_3D_VSO_COLOR_PLANES
+        riU, iUL,  iUR,  riV, iVL,  iVR,  
+#endif
+        iFilledL,  iFilledR, iDepthL,  iDepthR );
     }
     return;
@@ -1725,22 +1449,4 @@
     if ( abs ( iDepthDifference ) <= m_iBlendZThres )
     {
-      if      ((iFilledL == REN_IS_FILLED) && ( iFilledR != REN_IS_FILLED))
-      {
-        riY = xBlend( iYL, iYR, iFilledR >> 1 );
-#if H_3D_VSO_COLOR_PLANES
-        riU = xBlend( iUL, iUR, iFilledR >> 1 );
-        riV = xBlend( iVL, iVR, iFilledR >> 1 );
-#endif
-
-      }
-      else if ((iFilledL != REN_IS_FILLED) && ( iFilledR == REN_IS_FILLED))
-      {
-        riY = xBlend( iYR, iYL, (iFilledL >> 1) );
-#if H_3D_VSO_COLOR_PLANES
-        riU = xBlend( iUR, iUL, (iFilledL >> 1) );
-        riV = xBlend( iVR, iVL, (iFilledL >> 1) );
-#endif
-      }
-      else
       {
         riY = xBlend( iYL, iYR, m_iBlendDistWeight );
@@ -1760,5 +1466,5 @@
     }
     else
-    {
+    {      
       riY = iYR;
 #if H_3D_VSO_COLOR_PLANES
@@ -1808,10 +1514,10 @@
 }
 
-template <BlenMod iBM, Bool bBitInc> __inline Void
-#if H_3D_VSO_COLOR_PLANES
-TRenSingleModelC<iBM,bBitInc>::xGetBlendedValueBM1( Pel iYL, Pel iYR, Pel iUL, Pel iUR, Pel iVL, Pel iVR, Pel iDepthL, Pel iDepthR, Int iFilledL, Int iFilledR, Pel& riY, Pel& riU, Pel&riV )
-#else
-TRenSingleModelC<iBM,bBitInc>::xGetBlendedValueBM1( Pel iYL, Pel iYR, Pel iDepthL, Pel iDepthR, Int iFilledL, Int iFilledR, Pel& riY )
-#endif
+template <BlenMod iBM, Bool bBitInc> template< Bool bL, SetMod SM > __inline Void
+TRenSingleModelC<iBM,bBitInc>::xGetBlendedValueBM1( Pel& riY, Pel iYL,  Pel iYR,  
+#if H_3D_VSO_COLOR_PLANES
+                                                    Pel& riU, Pel iUL,  Pel iUR,  Pel& riV, Pel iVL,  Pel iVR,  
+#endif
+                                                    Int iFilledL,  Int iFilledR, Pel iDepthL,  Pel iDepthR  )
 {
   if ( iFilledL == REN_IS_FILLED ||  iFilledR == REN_IS_HOLE )
@@ -1841,10 +1547,10 @@
 }
 
-template <BlenMod iBM, Bool bBitInc> __inline Void
-#if H_3D_VSO_COLOR_PLANES
-TRenSingleModelC<iBM,bBitInc>::xGetBlendedValueBM2( Pel iYL, Pel iYR, Pel iUL, Pel iUR, Pel iVL, Pel iVR, Pel iDepthL, Pel iDepthR, Int iFilledL, Int iFilledR, Pel& riY, Pel& riU, Pel&riV )
-#else
-TRenSingleModelC<iBM,bBitInc>::xGetBlendedValueBM2( Pel iYL, Pel iYR, Pel iDepthL, Pel iDepthR, Int iFilledL, Int iFilledR, Pel& riY )
-#endif
+template <BlenMod iBM, Bool bBitInc> template< Bool bL, SetMod SM > __inline Void
+  TRenSingleModelC<iBM,bBitInc>::xGetBlendedValueBM2( Pel& riY, Pel iYL,  Pel iYR,  
+#if H_3D_VSO_COLOR_PLANES
+                                                      Pel& riU, Pel iUL,  Pel iUR,  Pel& riV, Pel iVL,  Pel iVR,  
+#endif
+                                                      Int iFilledL,  Int iFilledR, Pel iDepthL,  Pel iDepthR  )
 {
   if      ( iFilledR == REN_IS_FILLED ||  iFilledL == REN_IS_HOLE )
@@ -1899,10 +1605,9 @@
 
 #if H_3D_VSO_EARLY_SKIP
-template <BlenMod iBM, Bool bBitInc> 
-__inline Bool
-TRenSingleModelC<iBM,bBitInc>::xDetectEarlySkipL( Int iStartPosX, Int iStartPosY, Int iWidth, Int iHeight, Int iStride, const Pel* piNewData, const Pel* piOrgData, Int iOrgStride)
+template <BlenMod iBM, Bool bBitInc> template <Bool bL > __inline Bool
+TRenSingleModelC<iBM,bBitInc>::xDetectEarlySkip( Int iStartPosX, Int iStartPosY, Int iWidth, Int iHeight, Int iStride, const Pel* piNewData, const Pel* piOrgData, Int iOrgStride)
 {
   RM_AOF( m_bEarlySkip ); 
-  const Int iCurViewPos = 0;
+  const Int iCurViewPos = bL ? 0 : 1;
   Int** ppiCurLUT       = m_appiShiftLut   [ iCurViewPos ];
   
@@ -1930,37 +1635,4 @@
   return bNoDiff;
 }
-
-template <BlenMod iBM, Bool bBitInc> 
-__inline Bool
-TRenSingleModelC<iBM,bBitInc>::xDetectEarlySkipR( Int iStartPosX, Int iStartPosY, Int iWidth, Int iHeight, Int iStride, const Pel* piNewData, const Pel* piOrgData, Int iOrgStride)
-{
-  RM_AOF( m_bEarlySkip ); 
-  Bool bNoDiff  = true;
-
-  const Int iCurViewPos = 1;
-  Int** ppiCurLUT       = m_appiShiftLut   [ iCurViewPos ];
-
-  for ( Int iPosY = 0; iPosY < iHeight; iPosY++ )
-  {
-    m_pbHorSkip[iPosY] = true;
-
-    for (Int iPosX = 0; iPosX < iWidth; iPosX++)
-    {
-      Int iDisparityRec = abs( ppiCurLUT[0][ RenModRemoveBitInc(piNewData[iPosX])] );
-      Int iDisparityOrg = abs( ppiCurLUT[0][ RenModRemoveBitInc(piOrgData[iPosX])] );
-
-      if( iDisparityRec != iDisparityOrg )
-      {
-        m_pbHorSkip[iPosY] = false;
-        bNoDiff            = false;
-        break;
-      }
-    }
-
-    piNewData += iStride;
-    piOrgData += iOrgStride;
-  }
-  return bNoDiff;
-}
 #endif
 #endif // NH_3D
